Package virtuoso.jdbc4

## Class VirtuosoConnection

- java.lang.Object
- - virtuoso.jdbc4.VirtuosoConnection

All Implemented Interfaces:
  `java.lang.AutoCloseable`, `java.sql.Connection`, `java.sql.Wrapper`

    public class VirtuosoConnection
    extends java.lang.Object
    implements java.sql.Connection

The VirtuosoConnection class is an implementation of the Connection interface in the JDBC API which represents a database connection. A connection to the Virtuoso DBMS can be made with :

       Connection connection = DriverManager.getConnection(url,username,userpassword)

, in the case you use a URL like `jdbc:virtuoso://host:port` or

       Connection connection = DriverManager.getConnection(url)

, in the case you use a URL like `jdbc:virtuoso://host:port/UID=username/PWD=userpassword`

See Also:
  `Connection`, `DriverManager.getConnection(String)`, `VirtuosoStatement`, `VirtuosoPreparedStatement`, `VirtuosoCallableStatement`, `VirtuosoDatabaseMetaData`

### Nested Class Summary

Nested Classes
`protected class` `VirtuosoConnection.VhostRec`

### Field Summary

Fields
`protected java.lang.String` `charset`
`protected boolean` `charset_utf8`
`protected Vector` `client_charset`
`protected java.util.Hashtable<java.lang.Character,java.lang.Byte>` `client_charset_hash`
`protected Vector` `client_defaults`
`protected int` `fbs`
`protected VirtuosoPooledConnection` `pooled_connection`
`protected java.lang.String` `qualifier`
`protected java.util.Hashtable<java.lang.Integer,java.lang.String>` `rdf_lang_hash`
`protected boolean` `rdf_lang_loaded`
`protected java.util.Hashtable<java.lang.String,java.lang.Integer>` `rdf_lang_rev`
`protected java.util.Hashtable<java.lang.Integer,java.lang.String>` `rdf_type_hash`
`protected boolean` `rdf_type_loaded`
`protected java.util.Hashtable<java.lang.String,java.lang.Integer>` `rdf_type_rev`
`protected int` `timeout`
`protected int` `timeout_def`
`protected int` `timezoneless_datetimes`
`protected int` `txn_timeout`
`protected boolean` `utf8_execs`
`protected java.sql.SQLWarning` `warning`
`protected VirtuosoXAConnection` `xa_connection`

### Fields inherited from interface java.sql.Connection

`TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`void` `abort​(java.util.concurrent.Executor executor)` Terminates an open connection.
`protected void` `addStmtToClose​(VirtuosoStatement obj)`
`void` `beginRequest​()` Hints to the driver that a request, an independent unit of work, is beginning on this connection.
`protected byte[]` `charsetBytes​(java.lang.String source)`
`protected byte[]` `charsetBytes1​(java.lang.String source, java.lang.String from, java.lang.String to)`
`protected void` `checkHoldability​(int holdability)` supports only `ResultSet.HOLD_CURSORS_OVER_COMMIT` for now
`protected void` `clearFutures​()`
`void` `clearWarnings​()` Clears all the warnings reported on this Connection object.
`void` `close​()` Close the current connection previously established with Virtuoso DBMS.
`void` `commit​()` Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection.
`java.sql.Array` `createArrayOf​(java.lang.String typeName, java.lang.Object[] elements)` Factory method for creating Array objects.
`java.sql.Blob` `createBlob​()` Constructs an object that implements the `Blob` interface.
`java.sql.Clob` `createClob​()` Constructs an object that implements the `Clob` interface.
`java.sql.NClob` `createNClob​()` Constructs an object that implements the `NClob` interface.
`java.sql.SQLXML` `createSQLXML​()` Constructs an object that implements the `SQLXML` interface.
`java.sql.Statement` `createStatement​()` Creates a Statement object to send SQL statements to the Virtuoso DBMS.
`java.sql.Statement` `createStatement​(int resultSetType, int resultSetConcurrency)` Creates a Statement object that will generate ResultSet objects with the given type and concurrency.
`java.sql.Statement` `createStatement​(int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
`java.sql.Struct` `createStruct​(java.lang.String typeName, java.lang.Object[] attributes)` Factory method for creating Struct objects.
`void` `endRequest​()` Hints to the driver that a request, an independent unit of work, has completed.
`protected VirtuosoExplicitString` `escapeSQL​(java.lang.String sql)`
`protected VirtuosoExplicitString` `escapeSQLString​(java.lang.String sql)`
`void` `finalize​()` Method runs when the garbage collector want to erase the object
`boolean` `getAutoCommit​()` Returns the current auto-commit state.
`protected boolean` `getBoolAttr​(java.util.Properties info, java.lang.String key, boolean def)`
`protected int` `getCase​()` Method uses to get the case.
`java.lang.String` `getCatalog​()` Returns the Connection's current catalog name.
`java.util.Properties` `getClientInfo​()` Returns a list containing the name and current value of each client info property supported by the driver.
`java.lang.String` `getClientInfo​(java.lang.String name)` Returns the value of the client info property specified by name.
`protected virtuoso.jdbc4.VirtuosoFuture` `getFuture​(java.lang.String rpcname, java.lang.Object[] args, int timeout)` Start an RPC function call by sending a VirtuosoFuture request.
`int` `getHoldability​()` Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.
`protected int` `getIntAttr​(java.util.Properties info, java.lang.String key, int def)`
`java.sql.DatabaseMetaData` `getMetaData​()` Gets the metadata regarding this connection's database.
`int` `getNetworkTimeout​()` Retrieves the number of milliseconds the driver will wait for a database request to complete.
`protected java.lang.String` `getQualifierName​()` Method uses to get the qualifier name of this connection.
`java.lang.String` `getSchema​()` Retrieves this `Connection` object's current schema name.
`protected int` `getTimeout​()` Method uses to get the I/O timeout.
`int` `getTransactionIsolation​()` Gets this Connection's current transaction isolation level.
`java.util.Map<java.lang.String,java.lang.Class<?>>` `getTypeMap​()` Gets the type map object associated with this connection.
`protected java.lang.String` `getURL​()` Method uses to get the url of this connection.
`protected java.lang.String` `getUserName​()` Method uses to get the user name of this connection.
`protected java.lang.String` `getVersion​()` Method uses to get the version of the database.
`protected int` `getVersionNum​()`
`java.sql.SQLWarning` `getWarnings​()` Retrieves the first warning reported by calls on this Connection.
`int` `hashCode​()` Returns a hash code value for the object.
`boolean` `isClosed​()` Checks if the connection is closed.
`boolean` `isConnectionLost​(int timeout_sec)`
`static boolean` `isCriticalError​(java.sql.SQLException ex)`
`boolean` `isReadOnly​()` Check if the connection is in read-only mode.
`boolean` `isValid​(int _timeout)` Returns true if the connection has not been closed and is still valid.
`boolean` `isWrapperFor​(java.lang.Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`java.lang.String` `nativeSQL​(java.lang.String sql)` Converts the given SQL statement into the system's native SQL grammar.
`protected VirtuosoException` `notify_error​(java.lang.Throwable e)`
`protected java.util.Vector<VirtuosoConnection.VhostRec>` `parse_vhost​(java.lang.String vhost, java.lang.String _host, int _port)`
`java.sql.CallableStatement` `prepareCall​(java.lang.String sql)` Creates a CallableStatement object to call database stored procedures.
`java.sql.CallableStatement` `prepareCall​(java.lang.String sql, int resultSetType, int resultSetConcurrency)` Creates a CallableStatement object that will generate ResultSet objects with the given type and concurrency.
`java.sql.CallableStatement` `prepareCall​(java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` calls checkHoldability and then normal prepareCall
`java.sql.PreparedStatement` `prepareStatement​(java.lang.String sql)` Creates a PreparedStatement object to send parameterized SQL statements to the database.
`java.sql.PreparedStatement` `prepareStatement​(java.lang.String sql, int autoGeneratedKeys)` `autoGeneratedKeys` ignored
`java.sql.PreparedStatement` `prepareStatement​(java.lang.String sql, int[] columnIndexes)` `columnIndexes ignored` ignored
`java.sql.PreparedStatement` `prepareStatement​(java.lang.String sql, int resultSetType, int resultSetConcurrency)` Creates a PreparedStatement object that will generate ResultSet objects with the given type and concurrency.
`java.sql.PreparedStatement` `prepareStatement​(java.lang.String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
`java.sql.PreparedStatement` `prepareStatement​(java.lang.String sql, java.lang.String[] columnNames)` `columnNames ignored` ignored
`protected boolean` `read_request​()` Method uses to read messages and dispatch them between their future owner.
`protected void` `recacheStmt​(VirtuosoPreparedStatement ps)`
`void` `releaseSavepoint​(java.sql.Savepoint savepoint)` Removes the specified `Savepoint` and subsequent `Savepoint` objects from the current transaction.
`protected void` `removeFuture​(virtuoso.jdbc4.VirtuosoFuture fut)` Remove a future from the hashtable.
`protected void` `removeStmtFromClose​(VirtuosoStatement obj)`
`void` `rollback​()` Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection.
`void` `rollback​(java.sql.Savepoint savepoint)` Undoes all changes made after the given `Savepoint` object was set.
`void` `setAutoCommit​(boolean autoCommit)` Sets this connection's auto-commit mode.
`void` `setCatalog​(java.lang.String catalog)` Sets a catalog name in order to select a subspace of this Connection's database in which to work.
`void` `setClientInfo​(java.lang.String name, java.lang.String value)` Sets the value of the client info property specified by name to the value specified by value.
`void` `setClientInfo​(java.util.Properties properties)` Sets the value of the connection's client info properties.
`void` `setHoldability​(int holdability)` calls checkHoldability
`void` `setNetworkTimeout​(java.util.concurrent.Executor executor, int milliseconds)` Sets the maximum period a `Connection` or objects created from the `Connection` will wait for the database to reply to any one request.
`void` `setReadOnly​(boolean readOnly)` Puts this connection in read-only mode.
`java.sql.Savepoint` `setSavepoint​()` Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.
`java.sql.Savepoint` `setSavepoint​(java.lang.String name)` Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.
`void` `setSchema​(java.lang.String schema)` Sets the given schema name to access.
`protected void` `setSocketTimeout​(int timeout)`
`void` `setTransactionIsolation​(int level)` Attempts to change the transaction isolation level to the one given.
`void` `setTypeMap​(java.util.Map<java.lang.String,java.lang.Class<?>> map)` Installs the given type map as the type map for this connection.
`protected void` `setWarning​(java.sql.SQLWarning warn)`
`protected java.lang.String` `uncharsetBytes​(java.lang.String source)`
`<T> T` `unwrap​(java.lang.Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.
`protected void` `write_bytes​(byte[] bytes)`
`protected void` `write_object​(java.lang.Object obj)` Send an object to be sent on the output stream.

### Methods inherited from interface java.sql.Connection

`setShardingKey, setShardingKey, setShardingKeyIfValid, setShardingKeyIfValid`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### qualifier

    protected java.lang.String qualifier

#### client_defaults

    protected Vector client_defaults

#### client_charset

    protected Vector client_charset

#### client_charset_hash

    protected java.util.Hashtable<java.lang.Character,java.lang.Byte> client_charset_hash

#### warning

    protected java.sql.SQLWarning warning

#### timeout_def

    protected int timeout_def

#### timeout

    protected int timeout

#### txn_timeout

    protected int txn_timeout

#### fbs

    protected int fbs

#### utf8_execs

    protected boolean utf8_execs

#### timezoneless_datetimes

    protected int timezoneless_datetimes

#### pooled_connection

    protected VirtuosoPooledConnection pooled_connection

#### xa_connection

    protected VirtuosoXAConnection xa_connection

#### charset

    protected java.lang.String charset

#### charset_utf8

    protected boolean charset_utf8

#### rdf_type_hash

    protected java.util.Hashtable<java.lang.Integer,java.lang.String> rdf_type_hash

#### rdf_lang_hash

    protected java.util.Hashtable<java.lang.Integer,java.lang.String> rdf_lang_hash

#### rdf_type_rev

    protected java.util.Hashtable<java.lang.String,java.lang.Integer> rdf_type_rev

#### rdf_lang_rev

    protected java.util.Hashtable<java.lang.String,java.lang.Integer> rdf_lang_rev

#### rdf_type_loaded

    protected boolean rdf_type_loaded

#### rdf_lang_loaded

    protected boolean rdf_lang_loaded

### Method Detail

#### parse_vhost

    protected java.util.Vector<VirtuosoConnection.VhostRec> parse_vhost​(java.lang.String vhost,
                                                                        java.lang.String _host,
                                                                        int _port)
                                                                 throws VirtuosoException

Throws:
  `VirtuosoException`

#### isConnectionLost

    public boolean isConnectionLost​(int timeout_sec)

#### getIntAttr

    protected int getIntAttr​(java.util.Properties info,
                             java.lang.String key,
                             int def)

#### getBoolAttr

    protected boolean getBoolAttr​(java.util.Properties info,
                                  java.lang.String key,
                                  boolean def)

#### write_object

    protected void write_object​(java.lang.Object obj)
                         throws java.io.IOException,
                                VirtuosoException

Send an object to be sent on the output stream.

Parameters:
  `obj` - The object to send.
Throws:
  `VirtuosoException` - An internal error occurred.
  `java.io.IOException` - An ioexception occured

#### write_bytes

    protected void write_bytes​(byte[] bytes)
                        throws java.io.IOException,
                               VirtuosoException

Throws:
  `java.io.IOException`
  `VirtuosoException`

#### getFuture

    protected virtuoso.jdbc4.VirtuosoFuture getFuture​(java.lang.String rpcname,
                                                      java.lang.Object[] args,
                                                      int timeout)
                                               throws java.io.IOException,
                                                      VirtuosoException

Start an RPC function call by sending a VirtuosoFuture request.

Parameters:
  `rpcname` - The name of the RPC function.
  `args` - The array of arguments.
  `timeout` - The timeout for rpc call.
Returns:
  VirtuosoFuture The future instance.
Throws:
  `java.io.IOException` - An IO error occurred.
  `VirtuosoException` - An internal error occurred.

#### clearFutures

    protected void clearFutures​()

#### removeFuture

    protected void removeFuture​(virtuoso.jdbc4.VirtuosoFuture fut)

Remove a future from the hashtable.

Parameters:
  `fut` - The future to remove.

#### read_request

    protected boolean read_request​()
                            throws java.io.IOException,
                                   VirtuosoException

Method uses to read messages and dispatch them between their future owner.

Returns:
  boolean True if a message was dispatching.
Throws:
  `java.io.IOException` - A stream error occurred.
  `VirtuosoException` - An internal error occurred.

#### getURL

    protected java.lang.String getURL​()

Method uses to get the url of this connection.

Returns:
  String The url.

#### getUserName

    protected java.lang.String getUserName​()

Method uses to get the user name of this connection.

Returns:
  String The user name.

#### getQualifierName

    protected java.lang.String getQualifierName​()

Method uses to get the qualifier name of this connection.

Returns:
  String The qualifier name.

#### getVersion

    protected java.lang.String getVersion​()

Method uses to get the version of the database.

Returns:
  String The version number.

#### getVersionNum

    protected int getVersionNum​()

#### getCase

    protected int getCase​()

Method uses to get the case.

Returns:
  int The case.

#### getTimeout

    protected int getTimeout​()

Method uses to get the I/O timeout.

Returns:
  int the time out.

#### clearWarnings

    public void clearWarnings​()
                       throws VirtuosoException

Clears all the warnings reported on this Connection object. Virtuoso does not generate warnings, so this function does nothing, but we must declare it to be compliant with the JDBC API.

Specified by:
  `clearWarnings` in interface `java.sql.Connection`
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.clearWarnings()`

#### close

    public void close​()
               throws VirtuosoException

Close the current connection previously established with Virtuoso DBMS.

Specified by:
  `close` in interface `java.lang.AutoCloseable`
Specified by:
  `close` in interface `java.sql.Connection`
Throws:
  `VirtuosoException` - An error occurred during the connection.
See Also:
  `Connection.close()`

#### commit

    public void commit​()
                throws VirtuosoException

Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection. This method should be used only when auto-commit mode has been disabled.

Specified by:
  `commit` in interface `java.sql.Connection`
Throws:
  `VirtuosoException` - An internal error occurred.
See Also:
  `Connection.commit()`

#### createStatement

    public java.sql.Statement createStatement​()
                                       throws VirtuosoException

Creates a Statement object to send SQL statements to the Virtuoso DBMS. SQL statements without parameters are normally executed using Statement objects. If the same SQL statement is executed many times, it is more efficient to use a PreparedStatement. Result sets created using the returned Statement will have forward-only type, and read-only concurrency, by default.

Specified by:
  `createStatement` in interface `java.sql.Connection`
Returns:
  Statement A new Statement object.
Throws:
  `VirtuosoException` - A database access error occurred.
See Also:
  `Connection.createStatement()`, `VirtuosoStatement`

#### getAutoCommit

    public boolean getAutoCommit​()
                          throws VirtuosoException

Returns the current auto-commit state.

Specified by:
  `getAutoCommit` in interface `java.sql.Connection`
Returns:
  boolean The current state of auto-commit mode.
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.setAutoCommit(boolean)`

#### getMetaData

    public java.sql.DatabaseMetaData getMetaData​()
                                          throws VirtuosoException

Gets the metadata regarding this connection's database. A Connection's database is able to provide information describing its tables, its supported SQL grammar, its stored procedures, the capabilities of this connection, and so on. This information is made available through a DatabaseMetaData object.

Specified by:
  `getMetaData` in interface `java.sql.Connection`
Returns:
  a DatabaseMetaData object for this Connection
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.getMetaData()`, `VirtuosoDatabaseMetaData`

#### getWarnings

    public java.sql.SQLWarning getWarnings​()
                                    throws VirtuosoException

Retrieves the first warning reported by calls on this Connection. Subsequent Connection warnings will be chained to this SQLWarning. Virtuoso does not generate warnings, so this function returns always null.

Specified by:
  `getWarnings` in interface `java.sql.Connection`
Returns:
  SQLWarning The first SQLWarning or null (must be null for the moment)
Throws:
  `VirtuosoException` - No errors returned (just implementation).
See Also:
  `Connection.getWarnings()`

#### setTransactionIsolation

    public void setTransactionIsolation​(int level)
                                 throws VirtuosoException

Attempts to change the transaction isolation level to the one given. The constants defined in the interface `Connection` are the possible transaction isolation levels.

Specified by:
  `setTransactionIsolation` in interface `java.sql.Connection`
Parameters:
  `level` - one of the TRANSACTION_* isolation values with the exception of TRANSACTION_NONE; some databases may not support other values
Throws:
  `VirtuosoException` - An internal error occurred.
See Also:
  `Connection.setTransactionIsolation(int)`

#### getTransactionIsolation

    public int getTransactionIsolation​()
                                throws VirtuosoException

Gets this Connection's current transaction isolation level.

Specified by:
  `getTransactionIsolation` in interface `java.sql.Connection`
Returns:
  the current TRANSACTION_* mode value
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.getTransactionIsolation()`

#### isClosed

    public boolean isClosed​()

Checks if the connection is closed.

Specified by:
  `isClosed` in interface `java.sql.Connection`
Returns:
  boolean True if the connection is closed, false if it is still open.

#### prepareCall

    public java.sql.CallableStatement prepareCall​(java.lang.String sql)
                                           throws VirtuosoException

Creates a CallableStatement object to call database stored procedures. Result sets created using the returned CallableStatement will have forward-only type and read-only concurrency, by default.

Specified by:
  `prepareCall` in interface `java.sql.Connection`
Parameters:
  `sql` - a SQL statement that may contain one or more '?' parameter placeholders. Typically this statement is a JDBC function call escape string.
Returns:
  a new CallableStatement object containing the pre-compiled SQL statement
Throws:
  `VirtuosoException` - An internal error occurred.
See Also:
  `Connection.prepareCall(java.lang.String)`, `VirtuosoCallableStatement`

#### prepareStatement

    public java.sql.PreparedStatement prepareStatement​(java.lang.String sql)
                                                throws VirtuosoException

Creates a PreparedStatement object to send parameterized SQL statements to the database. Result sets created using the returned PreparedStatement will have forward-only type and read-only concurrency, by default.

Specified by:
  `prepareStatement` in interface `java.sql.Connection`
Parameters:
  `sql` - a SQL statement that may contain one or more '?' IN parameter placeholders
Returns:
  PreparedStatement A new PreparedStatement object.
Throws:
  `VirtuosoException` - A database access error occurs.
See Also:
  `Connection.prepareStatement(java.lang.String)`, `VirtuosoPreparedStatement`

#### rollback

    public void rollback​()
                  throws VirtuosoException

Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection. This method should be used only when auto-commit has been disabled.

Specified by:
  `rollback` in interface `java.sql.Connection`
Throws:
  `VirtuosoException` - An internal error occurred.
See Also:
  `Connection.rollback()`

#### setAutoCommit

    public void setAutoCommit​(boolean autoCommit)
                       throws VirtuosoException

Sets this connection's auto-commit mode. By default, new connections are in auto-commit mode.

Specified by:
  `setAutoCommit` in interface `java.sql.Connection`
Parameters:
  `autoCommit` - True enables auto-commit; false disables it.
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.setAutoCommit(boolean)`

#### createStatement

    public java.sql.Statement createStatement​(int resultSetType,
                                              int resultSetConcurrency)
                                       throws VirtuosoException

Creates a Statement object that will generate ResultSet objects with the given type and concurrency. This method is the same as the createStatement method above, but it allows the default result set type and result set concurrency type to be overridden.

Specified by:
  `createStatement` in interface `java.sql.Connection`
Parameters:
  `resultSetType` - A result set type; see VirtuosoResultSet.TYPE_XXX
  `resultSetConcurrency` - A concurrency type; see VirtuosoResultSet.CONCUR_XXX
Returns:
  Statement A new Statement object.
Throws:
  `VirtuosoException` - A database access error occurs.
See Also:
  `Connection.createStatement()`, `VirtuosoStatement`

#### prepareCall

    public java.sql.CallableStatement prepareCall​(java.lang.String sql,
                                                  int resultSetType,
                                                  int resultSetConcurrency)
                                           throws VirtuosoException

Creates a CallableStatement object that will generate ResultSet objects with the given type and concurrency. This method is the same as the createStatement method above, but it allows the default result set type and result set concurrency type to be overridden.

Specified by:
  `prepareCall` in interface `java.sql.Connection`
Parameters:
  `resultSetType` - a result set type; see VirtuosoResultSet.TYPE_XXX
  `resultSetConcurrency` - a concurrency type; see VirtuosoResultSet.CONCUR_XXX
Returns:
  a new CallableStatement object containing the pre-compiled SQL statement
Throws:
  `VirtuosoException` - A database access error occurs.
See Also:
  `Connection.prepareCall(java.lang.String)`, `VirtuosoCallableStatement`

#### prepareStatement

    public java.sql.PreparedStatement prepareStatement​(java.lang.String sql,
                                                       int resultSetType,
                                                       int resultSetConcurrency)
                                                throws VirtuosoException

Creates a PreparedStatement object that will generate ResultSet objects with the given type and concurrency. This method is the same as the prepareStatement method above, but it allows the default result set type and result set concurrency type to be overridden.

Specified by:
  `prepareStatement` in interface `java.sql.Connection`
Parameters:
  `sql` - a SQL statement that may contain one or more '?' IN parameter placeholders
  `resultSetType` - a result set type; see VirtuosoResultSet.TYPE_XXX
  `resultSetConcurrency` - a concurrency type; see VirtuosoResultSet.CONCUR_XXX
Returns:
  a new CallableStatement object containing the pre-compiled SQL statement
Throws:
  `VirtuosoException` - A database access error occurs.
See Also:
  `Connection.prepareCall(java.lang.String)`, `VirtuosoPreparedStatement`

#### hashCode

    public int hashCode​()

Returns a hash code value for the object.

Overrides:
  `hashCode` in class `java.lang.Object`
Returns:
  int The hash code value.

#### finalize

    public void finalize​()
                  throws java.lang.Throwable

Method runs when the garbage collector want to erase the object

Overrides:
  `finalize` in class `java.lang.Object`
Throws:
  `java.lang.Throwable`

#### isReadOnly

    public boolean isReadOnly​()
                       throws VirtuosoException

Check if the connection is in read-only mode.

Specified by:
  `isReadOnly` in interface `java.sql.Connection`
Returns:
  boolean True if connection is read-only and false otherwise.
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.isReadOnly()`

#### setReadOnly

    public void setReadOnly​(boolean readOnly)
                     throws VirtuosoException

Puts this connection in read-only mode.

Specified by:
  `setReadOnly` in interface `java.sql.Connection`
Parameters:
  `readOnly` - True enables read-only mode; false disables it.
Throws:
  `VirtuosoException` - An internal error occurred.
See Also:
  `Connection.setReadOnly(boolean)`

#### nativeSQL

    public java.lang.String nativeSQL​(java.lang.String sql)
                               throws VirtuosoException

Converts the given SQL statement into the system's native SQL grammar. A driver may convert the JDBC sql grammar into its system's native SQL grammar prior to sending it; this method returns the native form of the statement that the driver would have sent.

Specified by:
  `nativeSQL` in interface `java.sql.Connection`
Parameters:
  `sql` - a SQL statement that may contain one or more '?' parameter placeholders
Returns:
  the native form of this statement
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.nativeSQL(java.lang.String)`

#### setCatalog

    public void setCatalog​(java.lang.String catalog)
                    throws VirtuosoException

Sets a catalog name in order to select a subspace of this Connection's database in which to work. If the driver does not support catalogs, it will silently ignore this request.

Specified by:
  `setCatalog` in interface `java.sql.Connection`
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.setCatalog(java.lang.String)`

#### getCatalog

    public java.lang.String getCatalog​()
                                throws VirtuosoException

Returns the Connection's current catalog name.

Specified by:
  `getCatalog` in interface `java.sql.Connection`
Returns:
  the current catalog name or null
Throws:
  `VirtuosoException` - No errors returned (just an implementation question).
See Also:
  `Connection.getCatalog()`

#### getTypeMap

    public java.util.Map<java.lang.String,java.lang.Class<?>> getTypeMap​()
                                                                  throws VirtuosoException

Gets the type map object associated with this connection. Unless the application has added an entry to the type map, the map returned will be empty.

Specified by:
  `getTypeMap` in interface `java.sql.Connection`
Returns:
  the `java.util.Map` object associated with this `Connection` object
Throws:
  `VirtuosoException` - No errors returned (just implementation).
See Also:
  `Connection.getTypeMap()`

#### setTypeMap

    public void setTypeMap​(java.util.Map<java.lang.String,java.lang.Class<?>> map)
                    throws VirtuosoException

Installs the given type map as the type map for this connection. The type map will be used for the custom mapping of SQL structured types and distinct types.

Specified by:
  `setTypeMap` in interface `java.sql.Connection`
Parameters:
  `map` - `java.util.Map` object to install as the replacement for this `Connection` object's default type map
Throws:
  `VirtuosoException` - No errors returned (just implementation).
See Also:
  `Connection.setTypeMap(java.util.Map<java.lang.String, java.lang.Class<?>>)`

#### setSocketTimeout

    protected void setSocketTimeout​(int timeout)
                             throws VirtuosoException

Throws:
  `VirtuosoException`

#### escapeSQL

    protected VirtuosoExplicitString escapeSQL​(java.lang.String sql)
                                        throws VirtuosoException

Throws:
  `VirtuosoException`

#### escapeSQLString

    protected VirtuosoExplicitString escapeSQLString​(java.lang.String sql)
                                              throws VirtuosoException

Throws:
  `VirtuosoException`

#### charsetBytes1

    protected byte[] charsetBytes1​(java.lang.String source,
                                   java.lang.String from,
                                   java.lang.String to)
                            throws VirtuosoException

Throws:
  `VirtuosoException`

#### charsetBytes

    protected byte[] charsetBytes​(java.lang.String source)
                           throws VirtuosoException

Throws:
  `VirtuosoException`

#### uncharsetBytes

    protected java.lang.String uncharsetBytes​(java.lang.String source)
                                       throws VirtuosoException

Throws:
  `VirtuosoException`

#### checkHoldability

    protected void checkHoldability​(int holdability)
                             throws java.sql.SQLException

supports only `ResultSet.HOLD_CURSORS_OVER_COMMIT` for now

Parameters:
  `holdability` - a `ResultSet` holdability constant; one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Throws:
  `VirtuosoException` - if the holdability is not the supported one
  `java.sql.SQLException`

#### setHoldability

    public void setHoldability​(int holdability)
                        throws java.sql.SQLException

calls checkHoldability

Specified by:
  `setHoldability` in interface `java.sql.Connection`
Parameters:
  `holdability` - a `ResultSet` holdability constant; one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Throws:
  `java.sql.SQLException`
See Also:
  `checkHoldability(int)`

#### getHoldability

    public int getHoldability​()
                       throws java.sql.SQLException

Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.

Specified by:
  `getHoldability` in interface `java.sql.Connection`
Returns:
  the holdability, one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed connection
Since:
  1.4
See Also:
  `setHoldability(int)`, `DatabaseMetaData.getResultSetHoldability()`, `ResultSet`

#### setSavepoint

    public java.sql.Savepoint setSavepoint​()
                                    throws java.sql.SQLException

Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.

Specified by:
  `setSavepoint` in interface `java.sql.Connection`
Returns:
  the new `Savepoint` object
Throws:
  `VirtuosoException` - allways thrown : savepoints not supported
  `java.sql.SQLException`

#### setSavepoint

    public java.sql.Savepoint setSavepoint​(java.lang.String name)
                                    throws java.sql.SQLException

Creates an unnamed savepoint in the current transaction and returns the new `Savepoint` object that represents it.

Specified by:
  `setSavepoint` in interface `java.sql.Connection`
Parameters:
  `name` - a `String` containing the name of the savepoint
Returns:
  the new `Savepoint` object
Throws:
  `VirtuosoException` - allways thrown : savepoints not supported
  `java.sql.SQLException`

#### rollback

    public void rollback​(java.sql.Savepoint savepoint)
                  throws java.sql.SQLException

Undoes all changes made after the given `Savepoint` object was set.

This method should be used only when auto-commit has been disabled.

Specified by:
  `rollback` in interface `java.sql.Connection`
Parameters:
  `savepoint` - the `Savepoint` object to roll back to
Throws:
  `VirtuosoException` - allways thrown : savepoints not supported
  `java.sql.SQLException`

#### releaseSavepoint

    public void releaseSavepoint​(java.sql.Savepoint savepoint)
                          throws java.sql.SQLException

Removes the specified `Savepoint` and subsequent `Savepoint` objects from the current transaction. Any reference to the savepoint after it have been removed will cause an `SQLException` to be thrown.

Specified by:
  `releaseSavepoint` in interface `java.sql.Connection`
Parameters:
  `savepoint` - the `Savepoint` object to be removed
Throws:
  `VirtuosoException` - allways thrown : savepoints not supported
  `java.sql.SQLException`

#### createStatement

    public java.sql.Statement createStatement​(int resultSetType,
                                              int resultSetConcurrency,
                                              int resultSetHoldability)
                                       throws java.sql.SQLException

Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability. This method is the same as the `createStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden. Calls checkHoldability and then normal createStatement

Specified by:
  `createStatement` in interface `java.sql.Connection`
Parameters:
  `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Returns:
  a new `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method or this method is not supported for the specified result set type, result set holdability and result set concurrency.
See Also:
  `checkHoldability(int)`

#### prepareStatement

    public java.sql.PreparedStatement prepareStatement​(java.lang.String sql,
                                                       int resultSetType,
                                                       int resultSetConcurrency,
                                                       int resultSetHoldability)
                                                throws java.sql.SQLException

Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.

This method is the same as the `prepareStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden. Calls checkHoldability and then normal prepareStatement

Specified by:
  `prepareStatement` in interface `java.sql.Connection`
Parameters:
  `sql` - a `String` object that is the SQL statement to be sent to the database; may contain one or more '?' IN parameters
  `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Returns:
  a new `PreparedStatement` object, containing the pre-compiled SQL statement, that will generate `ResultSet` objects with the given type, concurrency, and holdability
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method or this method is not supported for the specified result set type, result set holdability and result set concurrency.
See Also:
  `checkHoldability(int)`

#### prepareCall

    public java.sql.CallableStatement prepareCall​(java.lang.String sql,
                                                  int resultSetType,
                                                  int resultSetConcurrency,
                                                  int resultSetHoldability)
                                           throws java.sql.SQLException

calls checkHoldability and then normal prepareCall

Specified by:
  `prepareCall` in interface `java.sql.Connection`
Throws:
  `java.sql.SQLException`
See Also:
  `checkHoldability(int)`

#### prepareStatement

    public java.sql.PreparedStatement prepareStatement​(java.lang.String sql,
                                                       int autoGeneratedKeys)
                                                throws java.sql.SQLException

`autoGeneratedKeys` ignored

Specified by:
  `prepareStatement` in interface `java.sql.Connection`
Throws:
  `java.sql.SQLException`

#### prepareStatement

    public java.sql.PreparedStatement prepareStatement​(java.lang.String sql,
                                                       int[] columnIndexes)
                                                throws java.sql.SQLException

`columnIndexes ignored` ignored

Specified by:
  `prepareStatement` in interface `java.sql.Connection`
Throws:
  `java.sql.SQLException`

#### prepareStatement

    public java.sql.PreparedStatement prepareStatement​(java.lang.String sql,
                                                       java.lang.String[] columnNames)
                                                throws java.sql.SQLException

`columnNames ignored` ignored

Specified by:
  `prepareStatement` in interface `java.sql.Connection`
Throws:
  `java.sql.SQLException`

#### createClob

    public java.sql.Clob createClob​()
                             throws java.sql.SQLException

Constructs an object that implements the `Clob` interface. The object returned initially contains no data. The `setAsciiStream`, `setCharacterStream` and `setString` methods of the `Clob` interface may be used to add data to the `Clob`.

Specified by:
  `createClob` in interface `java.sql.Connection`
Returns:
  An object that implements the `Clob` interface
Throws:
  `java.sql.SQLException` - if an object that implements the `Clob` interface cannot be constructed, this method is called on a closed connection or a database access error occurs.
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this data type
Since:
  1.6

#### createBlob

    public java.sql.Blob createBlob​()
                             throws java.sql.SQLException

Constructs an object that implements the `Blob` interface. The object returned initially contains no data. The `setBinaryStream` and `setBytes` methods of the `Blob` interface may be used to add data to the `Blob`.

Specified by:
  `createBlob` in interface `java.sql.Connection`
Returns:
  An object that implements the `Blob` interface
Throws:
  `java.sql.SQLException` - if an object that implements the `Blob` interface cannot be constructed, this method is called on a closed connection or a database access error occurs.
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this data type
Since:
  1.6

#### createNClob

    public java.sql.NClob createNClob​()
                               throws java.sql.SQLException

Constructs an object that implements the `NClob` interface. The object returned initially contains no data. The `setAsciiStream`, `setCharacterStream` and `setString` methods of the `NClob` interface may be used to add data to the `NClob`.

Specified by:
  `createNClob` in interface `java.sql.Connection`
Returns:
  An object that implements the `NClob` interface
Throws:
  `java.sql.SQLException` - if an object that implements the `NClob` interface cannot be constructed, this method is called on a closed connection or a database access error occurs.
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this data type
Since:
  1.6

#### createSQLXML

    public java.sql.SQLXML createSQLXML​()
                                 throws java.sql.SQLException

Constructs an object that implements the `SQLXML` interface. The object returned initially contains no data. The `createXmlStreamWriter` object and `setString` method of the `SQLXML` interface may be used to add data to the `SQLXML` object.

Specified by:
  `createSQLXML` in interface `java.sql.Connection`
Returns:
  An object that implements the `SQLXML` interface
Throws:
  `java.sql.SQLException` - if an object that implements the `SQLXML` interface cannot be constructed, this method is called on a closed connection or a database access error occurs.
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this data type
Since:
  1.6

#### isValid

    public boolean isValid​(int _timeout)
                    throws java.sql.SQLException

Returns true if the connection has not been closed and is still valid. The driver shall submit a query on the connection or use some other mechanism that positively verifies the connection is still valid when this method is called.

The query submitted by the driver to validate the connection shall be executed in the context of the current transaction.

Specified by:
  `isValid` in interface `java.sql.Connection`
Parameters:
  `_timeout` - - The time in seconds to wait for the database operation used to validate the connection to complete. If the timeout period expires before the operation completes, this method returns false. A value of 0 indicates a timeout is not applied to the database operation.

Returns:
  true if the connection is valid, false otherwise
Throws:
  `java.sql.SQLException` - if the value supplied for `timeout` is less then 0
Since:
  1.6
See Also:
  `DatabaseMetaData.getClientInfoProperties()`

#### setClientInfo

    public void setClientInfo​(java.lang.String name,
                              java.lang.String value)
                       throws java.sql.SQLClientInfoException

Sets the value of the client info property specified by name to the value specified by value.

Applications may use the `DatabaseMetaData.getClientInfoProperties` method to determine the client info properties supported by the driver and the maximum length that may be specified for each property.

The driver stores the value specified in a suitable location in the database. For example in a special register, session parameter, or system table column. For efficiency the driver may defer setting the value in the database until the next time a statement is executed or prepared. Other than storing the client information in the appropriate place in the database, these methods shall not alter the behavior of the connection in anyway. The values supplied to these methods are used for accounting, diagnostics and debugging purposes only.

The driver shall generate a warning if the client info name specified is not recognized by the driver.

If the value specified to this method is greater than the maximum length for the property the driver may either truncate the value and generate a warning or generate a `SQLClientInfoException`. If the driver generates a `SQLClientInfoException`, the value specified was not set on the connection.

The following are standard client info properties. Drivers are not required to support these properties however if the driver supports a client info property that can be described by one of the standard properties, the standard property name should be used.

- ApplicationName - The name of the application currently utilizing the connection
- ClientUser - The name of the user that the application using the connection is performing work for. This may not be the same as the user name that was used in establishing the connection.
- ClientHostname - The hostname of the computer the application using the connection is running on.

Specified by:
  `setClientInfo` in interface `java.sql.Connection`
Parameters:
  `name` - The name of the client info property to set
  `value` - The value to set the client info property to. If the value is null, the current value of the specified property is cleared.

Throws:
  `java.sql.SQLClientInfoException` - if the database server returns an error while setting the client info value on the database server or this method is called on a closed connection

Since:
  1.6

#### setClientInfo

    public void setClientInfo​(java.util.Properties properties)
                       throws java.sql.SQLClientInfoException

Sets the value of the connection's client info properties. The `Properties` object contains the names and values of the client info properties to be set. The set of client info properties contained in the properties list replaces the current set of client info properties on the connection. If a property that is currently set on the connection is not present in the properties list, that property is cleared. Specifying an empty properties list will clear all of the properties on the connection. See `setClientInfo (String, String)` for more information.

If an error occurs in setting any of the client info properties, a `SQLClientInfoException` is thrown. The `SQLClientInfoException` contains information indicating which client info properties were not set. The state of the client information is unknown because some databases do not allow multiple client info properties to be set atomically. For those databases, one or more properties may have been set before the error occurred.

Specified by:
  `setClientInfo` in interface `java.sql.Connection`
Parameters:
  `properties` - the list of client info properties to set

Throws:
  `java.sql.SQLClientInfoException` - if the database server returns an error while setting the clientInfo values on the database server or this method is called on a closed connection
Since:
  1.6

See Also:
  `setClientInfo(String, String)`

#### getClientInfo

    public java.lang.String getClientInfo​(java.lang.String name)
                                   throws java.sql.SQLException

Returns the value of the client info property specified by name. This method may return null if the specified client info property has not been set and does not have a default value. This method will also return null if the specified client info property name is not supported by the driver.

Applications may use the `DatabaseMetaData.getClientInfoProperties` method to determine the client info properties supported by the driver.

Specified by:
  `getClientInfo` in interface `java.sql.Connection`
Parameters:
  `name` - The name of the client info property to retrieve

Returns:
  The value of the client info property specified

Throws:
  `java.sql.SQLException` - if the database server returns an error when fetching the client info value from the database or this method is called on a closed connection

Since:
  1.6
See Also:
  `DatabaseMetaData.getClientInfoProperties()`

#### getClientInfo

    public java.util.Properties getClientInfo​()
                                       throws java.sql.SQLException

Returns a list containing the name and current value of each client info property supported by the driver. The value of a client info property may be null if the property has not been set and does not have a default value.

Specified by:
  `getClientInfo` in interface `java.sql.Connection`
Returns:
  A `Properties` object that contains the name and current value of each of the client info properties supported by the driver.

Throws:
  `java.sql.SQLException` - if the database server returns an error when fetching the client info values from the database or this method is called on a closed connection

Since:
  1.6

#### createArrayOf

    public java.sql.Array createArrayOf​(java.lang.String typeName,
                                        java.lang.Object[] elements)
                                 throws java.sql.SQLException

Factory method for creating Array objects.

Note: When `createArrayOf` is used to create an array object that maps to a primitive data type, then it is implementation-defined whether the `Array` object is an array of that primitive data type or an array of `Object`.

Note: The JDBC driver is responsible for mapping the elements `Object` array to the default JDBC SQL type defined in java.sql.Types for the given class of `Object`. The default mapping is specified in Appendix B of the JDBC specification. If the resulting JDBC type is not the appropriate type for the given typeName then it is implementation defined whether an `SQLException` is thrown or the driver supports the resulting conversion.

Specified by:
  `createArrayOf` in interface `java.sql.Connection`
Parameters:
  `typeName` - the SQL name of the type the elements of the array map to. The typeName is a database-specific name which may be the name of a built-in type, a user-defined type or a standard SQL type supported by this database. This is the value returned by `Array.getBaseTypeName`
  `elements` - the elements that populate the returned object
Returns:
  an Array object whose elements map to the specified SQL type
Throws:
  `java.sql.SQLException` - if a database error occurs, the JDBC type is not appropriate for the typeName and the conversion is not supported, the typeName is null or this method is called on a closed connection
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this data type
Since:
  1.6

#### createStruct

    public java.sql.Struct createStruct​(java.lang.String typeName,
                                        java.lang.Object[] attributes)
                                 throws java.sql.SQLException

Factory method for creating Struct objects.

Specified by:
  `createStruct` in interface `java.sql.Connection`
Parameters:
  `typeName` - the SQL type name of the SQL structured type that this `Struct` object maps to. The typeName is the name of a user-defined type that has been defined for this database. It is the value returned by `Struct.getSQLTypeName`.
  `attributes` - the attributes that populate the returned object
Returns:
  a Struct object that maps to the given SQL type and is populated with the given attributes
Throws:
  `java.sql.SQLException` - if a database error occurs, the typeName is null or this method is called on a closed connection
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this data type
Since:
  1.6

#### unwrap

    public <T> T unwrap​(java.lang.Class<T> iface)
                 throws java.sql.SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `java.sql.Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. May be a proxy for the actual implementing object.
Throws:
  `java.sql.SQLException` - If no object found that implements the interface
Since:
  1.6

#### isWrapperFor

    public boolean isWrapperFor​(java.lang.Class<?> iface)
                         throws java.sql.SQLException

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `java.sql.Wrapper`
Parameters:
  `iface` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.
Throws:
  `java.sql.SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
Since:
  1.6

#### setSchema

    public void setSchema​(java.lang.String schema)
                   throws java.sql.SQLException

Sets the given schema name to access.

If the driver does not support schemas, it will silently ignore this request.

Calling `setSchema` has no effect on previously created or prepared `Statement` objects. It is implementation defined whether a DBMS prepare operation takes place immediately when the `Connection` method `prepareStatement` or `prepareCall` is invoked. For maximum portability, `setSchema` should be called before a `Statement` is created or prepared.

Specified by:
  `setSchema` in interface `java.sql.Connection`
Parameters:
  `schema` - the name of a schema in which to work
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed connection
Since:
  1.7
See Also:
  `getSchema()`

#### getSchema

    public java.lang.String getSchema​()
                               throws java.sql.SQLException

Retrieves this `Connection` object's current schema name.

Specified by:
  `getSchema` in interface `java.sql.Connection`
Returns:
  the current schema name or `null` if there is none
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed connection
Since:
  1.7
See Also:
  `setSchema(java.lang.String)`

#### abort

    public void abort​(java.util.concurrent.Executor executor)
               throws java.sql.SQLException

Terminates an open connection. Calling `abort` results in:

- The connection marked as closed
- Closes any physical connection to the database
- Releases resources used by the connection
- Insures that any thread that is currently accessing the connection will either progress to completion or throw an `SQLException`.

Calling `abort` marks the connection closed and releases any resources. Calling `abort` on a closed connection is a no-op.

It is possible that the aborting and releasing of the resources that are held by the connection can take an extended period of time. When the `abort` method returns, the connection will have been marked as closed and the `Executor` that was passed as a parameter to abort may still be executing tasks to release resources.

This method checks to see that there is an `SQLPermission` object before allowing the method to proceed. If a `SecurityManager` exists and its `checkPermission` method denies calling `abort`, this method throws a `java.lang.SecurityException`.

Specified by:
  `abort` in interface `java.sql.Connection`
Parameters:
  `executor` - The `Executor` implementation which will be used by `abort`.
Throws:
  `java.sql.SQLException` - if a database access error occurs or the `executor` is `null`,
  `java.lang.SecurityException` - if a security manager exists and its `checkPermission` method denies calling `abort`
Since:
  1.7
See Also:
  `SecurityManager.checkPermission(java.security.Permission)`, `Executor`

#### setNetworkTimeout

    public void setNetworkTimeout​(java.util.concurrent.Executor executor,
                                  int milliseconds)
                           throws java.sql.SQLException

Sets the maximum period a `Connection` or objects created from the `Connection` will wait for the database to reply to any one request. If any request remains unanswered, the waiting method will return with a `SQLException`, and the `Connection` or objects created from the `Connection` will be marked as closed. Any subsequent use of the objects, with the exception of the `close`, `isClosed` or `Connection.isValid` methods, will result in a `SQLException`.

Note: This method is intended to address a rare but serious condition where network partitions can cause threads issuing JDBC calls to hang uninterruptedly in socket reads, until the OS TCP-TIMEOUT (typically 10 minutes). This method is related to the `abort()` method which provides an administrator thread a means to free any such threads in cases where the JDBC connection is accessible to the administrator thread. The `setNetworkTimeout` method will cover cases where there is no administrator thread, or it has no access to the connection. This method is severe in it is effects, and should be given a high enough value so it is never triggered before any more normal timeouts, such as transaction timeouts.

JDBC driver implementations may also choose to support the `setNetworkTimeout` method to impose a limit on database response time, in environments where no network is present.

Drivers may internally implement some or all of their API calls with multiple internal driver-database transmissions, and it is left to the driver implementation to determine whether the limit will be applied always to the response to the API call, or to any single request made during the API call.

This method can be invoked more than once, such as to set a limit for an area of JDBC code, and to reset to the default on exit from this area. Invocation of this method has no impact on already outstanding requests.

The `Statement.setQueryTimeout()` timeout value is independent of the timeout value specified in `setNetworkTimeout`. If the query timeout expires before the network timeout then the statement execution will be canceled. If the network is still active the result will be that both the statement and connection are still usable. However if the network timeout expires before the query timeout or if the statement timeout fails due to network problems, the connection will be marked as closed, any resources held by the connection will be released and both the connection and statement will be unusable.

When the driver determines that the `setNetworkTimeout` timeout value has expired, the JDBC driver marks the connection closed and releases any resources held by the connection.

This method checks to see that there is an `SQLPermission` object before allowing the method to proceed. If a `SecurityManager` exists and its `checkPermission` method denies calling `setNetworkTimeout`, this method throws a `java.lang.SecurityException`.

Specified by:
  `setNetworkTimeout` in interface `java.sql.Connection`
Parameters:
  `executor` - The `Executor` implementation which will be used by `setNetworkTimeout`.
  `milliseconds` - The time in milliseconds to wait for the database operation to complete. If the JDBC driver does not support milliseconds, the JDBC driver will round the value up to the nearest second. If the timeout period expires before the operation completes, a SQLException will be thrown. A value of 0 indicates that there is not timeout for database operations.
Throws:
  `java.sql.SQLException` - if a database access error occurs, this method is called on a closed connection, the `executor` is `null`, or the value specified for `seconds` is less than 0.
  `java.lang.SecurityException` - if a security manager exists and its `checkPermission` method denies calling `setNetworkTimeout`.
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.7
See Also:
  `SecurityManager.checkPermission(java.security.Permission)`, `Statement.setQueryTimeout(int)`, `getNetworkTimeout()`, `abort(java.util.concurrent.Executor)`, `Executor`

#### getNetworkTimeout

    public int getNetworkTimeout​()
                          throws java.sql.SQLException

Retrieves the number of milliseconds the driver will wait for a database request to complete. If the limit is exceeded, a `SQLException` is thrown.

Specified by:
  `getNetworkTimeout` in interface `java.sql.Connection`
Returns:
  the current timeout limit in milliseconds; zero means there is no limit
Throws:
  `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Connection`
  `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.7
See Also:
  `setNetworkTimeout(java.util.concurrent.Executor, int)`

#### beginRequest

    public void beginRequest​()
                      throws java.sql.SQLException

Hints to the driver that a request, an independent unit of work, is beginning on this connection. Each request is independent of all other requests with regard to state local to the connection either on the client or the server. Work done between `beginRequest`, `endRequest` pairs does not depend on any other work done on the connection either as part of another request or outside of any request. A request may include multiple transactions. There may be dependencies on committed database state as that is not local to the connection.

Local state is defined as any state associated with a Connection that is local to the current Connection either in the client or the database that is not transparently reproducible.

Calls to `beginRequest` and `endRequest` are not nested. Multiple calls to `beginRequest` without an intervening call to `endRequest` is not an error. The first `beginRequest` call marks the start of the request and subsequent calls are treated as a no-op

Use of `beginRequest` and `endRequest` is optional, vendor specific and should largely be transparent. In particular implementations may detect conditions that indicate dependence on other work such as an open transaction. It is recommended though not required that implementations throw a `SQLException` if there is an active transaction and `beginRequest` is called. Using these methods may improve performance or provide other benefits. Consult your vendors documentation for additional information.

It is recommended to enclose each unit of work in `beginRequest`, `endRequest` pairs such that there is no open transaction at the beginning or end of the request and no dependency on local state that crosses request boundaries. Committed database state is not local. implSpec The default implementation is a no-op. apiNote This method is to be used by Connection pooling managers.

The pooling manager should call `beginRequest` on the underlying connection prior to returning a connection to the caller.

The pooling manager does not need to call `beginRequest` if:

- The connection pool caches `PooledConnection` objects
- Returns a logical connection handle when `getConnection` is called by the application
- The logical `Connection` is closed by calling `Connection.close` prior to returning the `PooledConnection` to the cache.

Specified by:
  `beginRequest` in interface `java.sql.Connection`
Throws:
  `java.sql.SQLException` - if an error occurs
Since:
  9
See Also:
  `endRequest()`, `PooledConnection`

#### endRequest

    public void endRequest​()
                    throws java.sql.SQLException

Hints to the driver that a request, an independent unit of work, has completed. Calls to `beginRequest` and `endRequest` are not nested. Multiple calls to `endRequest` without an intervening call to `beginRequest` is not an error. The first `endRequest` call marks the request completed and subsequent calls are treated as a no-op. If `endRequest` is called without an initial call to `beginRequest` is a no-op.

The exact behavior of this method is vendor specific. In particular implementations may detect conditions that indicate dependence on other work such as an open transaction. It is recommended though not required that implementations throw a `SQLException` if there is an active transaction and `endRequest` is called. implSpec The default implementation is a no-op. apiNote This method is to be used by Connection pooling managers.

The pooling manager should call `endRequest` on the underlying connection when the applications returns the connection back to the connection pool.

The pooling manager does not need to call `endRequest` if:

- The connection pool caches `PooledConnection` objects
- Returns a logical connection handle when `getConnection` is called by the application
- The logical `Connection` is closed by calling `Connection.close` prior to returning the `PooledConnection` to the cache.

Specified by:
  `endRequest` in interface `java.sql.Connection`
Throws:
  `java.sql.SQLException` - if an error occurs
Since:
  9
See Also:
  `beginRequest()`, `PooledConnection`

#### addStmtToClose

    protected void addStmtToClose​(VirtuosoStatement obj)

#### removeStmtFromClose

    protected void removeStmtFromClose​(VirtuosoStatement obj)

#### recacheStmt

    protected void recacheStmt​(VirtuosoPreparedStatement ps)
                        throws java.sql.SQLException

Throws:
  `java.sql.SQLException`

#### setWarning

    protected void setWarning​(java.sql.SQLWarning warn)

#### notify_error

    protected VirtuosoException notify_error​(java.lang.Throwable e)

#### isCriticalError

    public static boolean isCriticalError​(java.sql.SQLException ex)